#ifndef STACK_H
#define STACK_H

#include <stddef.h>


typedef float stack_value_t;

struct stack;
typedef struct stack stack_t;


stack_t *stack_create();
void stack_delete(stack_t *self);

void stack_construct(stack_t *self);
void stack_destroy(stack_t *self);

size_t stack_size(const stack_t *self);

void stack_push(stack_t *self, stack_value_t val);
stack_value_t stack_pop(stack_t *self);
stack_value_t stack_peek(const stack_t *self);

#endif // STACK_H
