#include "person.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

person_t *person_create(const char *name)
{
    person_t *person = malloc(sizeof(person_t));
    person_construct(person, name);
    return person;
}

void person_delete(person_t *person)
{
    person_destruct(person);
    free(person);
}

void person_construct(person_t *person, const char *name)
{
    person->name = malloc(strlen(name)+1);
    strcpy(person->name, name);
}

void person_destruct(person_t *person)
{
    free(person->name);
    person->name = NULL;
}

void person_print(person_t *person)
{
    printf("name: %s\n", person->name);
}

// Student

student_t *student_create(const char *name, int number)
{
    student_t *student = malloc(sizeof(student_t));
    student_construct(student, name, number);
    return student;
}

void student_delete(student_t *student)
{
    student_destruct(student);
    free(student);
}

void student_construct(student_t *student, const char *name, int number)
{
    person_construct(&student->super, name);
    student->number = number;
}

void student_destruct(student_t *student)
{
    person_destruct(&student->super);
}

void student_print(student_t *student)
{
    person_print(&student->super);
    printf("number: %d\n", student->number);
}
