#ifndef PERSON_H
#define PERSON_H

// Person

struct person
{
    const void  *vtab;
    char        *name;
};

typedef struct person person_t;

person_t *person_create(const char *name);
void person_delete(person_t *person);
void person_construct(person_t *person, const char *name);
void person_destruct(person_t *person);
void person_print(const person_t *person);

void person_vdelete(person_t *person);
void person_vprint(const person_t *person);

// Student

struct student
{
    person_t    super;
    int         number;
};

typedef struct student student_t;

student_t *student_create(const char *name, int number);
void student_delete(student_t *student);
void student_construct(student_t *student, const char *name, int number);
void student_destruct(student_t *student);
void student_print(const student_t *student);

#endif // PERSON_H
